//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ThreadUnit.h"
#include "MainUnit.h"

#pragma package(smart_init)
extern PACKAGE N;
int i;
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall My_Thread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall My_Thread::My_Thread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall My_Thread::Execute()
{
        //---- Place thread code here ----
        FreeOnTerminate = true;
        Synchronize(StartEnableButtons);
        for(i = 0; i<1000; i++)
        {
         if(Terminated) break;
         Synchronize(UpdateProgressBar);
        }
        Terminate();
        Synchronize(EndEnableButtons);
}
//---------------------------------------------------------------------------
void __fastcall My_Thread::UpdateProgressBar()
{

  Form1->ProgressBar1->Position = i;
  Sleep(10);
  Application->ProcessMessages();
}

void __fastcall My_Thread::StartEnableButtons()
{
 Form1->Button4->Enabled = false;
 Form1->Button1->Enabled = true;
 Form1->Button2->Enabled = true;
 Form1->Button3->Enabled = true;
}
void __fastcall My_Thread::EndEnableButtons()
{
 Form1->Button4->Enabled = true;
 Form1->Button1->Enabled = false;
 Form1->Button2->Enabled = false;
 Form1->Button3->Enabled = false;
}

void __fastcall My_Thread::OnTerminate()
{
 Synchronize(EndEnableButtons);
}
